/**
 * Mixin for scope
 * @function scopeMixin
 */
'use strict'

/** @lends scopeMixin */
function scopeMixin (BaseClass) {
  return class ScopeMixed extends BaseClass {
    scopeValue (...keys) {
      const s = this
      s.assertScopeName()
      let { scopeName } = s
      return s.get(scopeName, ...keys)
    }

    scopeOperate (operationType, fieldName, value) {
      const s = this
      s.assertScopeName()
      let { scopeName } = s
      let actionType = `${scopeName}:${operationType}`
      return s.dispatch(actionType, fieldName, value)
    }

    assertScopeName () {
      const s = this
      let { scopeName } = s
      if (!scopeName) {
        throw new Error('[ScopeMixin] scopeName is missing!')
      }
    }
  }
}

module.exports = scopeMixin
