/**
 * Reducer for apeman service
 * @function reducer
 * */
'use strict'

const ERROR_SCOPE_NAME = 'errors'
const { assign } = require('asobj')
const {
  reducer: operationReducer
} = require('bredux-operate')

/** @lends reducer */
function reducer (state = { [ERROR_SCOPE_NAME]: {} }, action) {
  let { type, payload, meta = {}, error: isError } = action
  if (isError) {
    let errorState = state[ ERROR_SCOPE_NAME ]
    return assign(state, {
      [ERROR_SCOPE_NAME]: reducer(errorState, { type, payload, meta })
    })
  }
  let [scopeName, operationName] = type.split(':')
  if (!operationName) {
    return state
  }
  let scopeState = state[ scopeName ]
  return assign({}, state, {
    [scopeName]: operationReducer(scopeState, { type: operationName, payload, meta })
  })
}

module.exports = reducer
